TITAN_HONOR_ID = "Honor";


TITAN_HONOR_CFG = { };

TITAN_HONOR_KILLSTODAY = {};
TITAN_HONOR_KILLSLIFETIME = {};

TITAN_HONOR_LASTKILL = "";
TITAN_HONOR_PLAYER = nil;
TITAN_HONOR_VARSLOADED = false;
TITAN_HONOR_PENDINGUPDATE = false;
TITAN_HONOR_LASTWIN_TIMESTAMP = 0;

TITAN_HONOR_LastEstimated = 0;
TITAN_HONOR_InBattleground = false;
TITAN_HONOR_Map = "";
TITAN_HONOR_EnterTime = 0;

function TitanPanelHonorButton_OnLoad()

	this.registry = {
		id = TITAN_HONOR_ID,
		builtIn = 0,
		version = 1.01,
		menuText = "Honor",
		buttonTextFunction = "TitanPanelHonorButton_GetButtonText", 
		tooltipTitle ="HonorCount", 
		tooltipTextFunction = "TitanPanelHonorButton_GetTooltipText", 
		savedVariables = {
			ShowLabelText = 1,
		}
	};	

 	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
end

function TitanPanelHonorButton_OnEvent()
	if (event == "PLAYER_ENTERING_WORLD") then
		
		if (TITAN_HONOR_VARSLOADED) then
			TitanPanelHonorButton_GetPlayerName();
		else
			TITAN_HONOR_PENDINGUPDATE = true;
		end

		
		-- is player entering or leaving a BG?
		local i, id, map, elapsed, gained;
		for i=1, MAX_BATTLEFIELD_QUEUES do

			_, map, id = GetBattlefieldStatus(i);
			if (id ~= 0) then

				-- Player entering a BG

				TITAN_HONOR_InBattleground = true;
				TITAN_HONOR_Map = map;
				TITAN_HONOR_LastEstimated = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP;
				TITAN_HONOR_EnterTime = time();

				return
			end
		end

		if (TITAN_HONOR_InBattleground) then

			-- Player just left a BG

			gained = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP - TITAN_HONOR_LastEstimated);
			elapsed = math.floor( (time() - TITAN_HONOR_EnterTime) / 60 );

			local tmp_gained;

			tmp_gained = gained;

			if (gained < 0) then
				gained = "?";
				tmp_gained = "unknown (daily reset possible).";
			end



			DEFAULT_CHAT_FRAME:AddMessage(TITAN_HONOR_Map.." ended.  Time Elapsed: "..elapsed.." minutes   Honor gained: "..tmp_gained..".");


			-- ?
			if (TITAN_HONOR_Map == "Eastern Kingdoms") then
				return
			end


			-- BG Honor History
			if (elapsed > 2 and gained ~= "?") then
				if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map]) then
					TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map] = {};
				end

				table.insert(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map], { honor = gained, time = elapsed } );
				if (table.getn(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map]) > 10) then
					table.remove(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map], 1);
				end
			end

			TITAN_HONOR_InBattleground = false;
		end


	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
		local rank, ecp, est;

		_, _, TITAN_HONOR_LASTKILL, rank, ecp = string.find(arg1, TITAN_HONOR_HONORKILL);
		

		if (not TITAN_HONOR_LASTKILL) then

			_, _, TITAN_HONOR_LASTKILL = string.find(arg1, TITAN_HONOR_HONORGAIN);
			if (TITAN_HONOR_LASTKILL) then
				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP + tonumber(TITAN_HONOR_LASTKILL);
			end

		else

			if (not TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL]) then
				TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] = 0;
			end

			TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] = TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] + 1;

			if (ecp) then
				est = TitanPanelHonorButton_EstimateCP(ecp);

				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP + est;
			end

			DEFAULT_CHAT_FRAME:AddMessage("Honor kill: "..TITAN_HONOR_LASTKILL.." (kills today: "..TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL]..")  Est. Honor: "..math.floor(est));
		end

	elseif (event == "VARIABLES_LOADED") then
		TITAN_HONOR_VARSLOADED = true;
		if (TITAN_HONOR_PENDINGUPDATE) then
			TitanPanelHonorButton_GetPlayerName();
		end
	end

	TitanPanelButton_UpdateButton(TITAN_HONOR_ID);		
end

function TitanPanelHonorButton_OnClick(button)

--	DEFAULT_CHAT_FRAME:AddMessage("TEST: "..TITAN_HONOR_Map);
end

function TitanPanelHonorButton_GetButtonText(id)
	
	if(not TITAN_HONOR_PLAYER) then
		return format("Points: %s HK: %s (Loading...)", TitanUtils_GetHighlightText(0), TitanUtils_GetGreenText(0));
	end
	
	local Text, z, cp;

	z = 0;
	if(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) then
		for _ in pairs(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) do
			z = z + 1;
		end
	end

	cp = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP);

	Text = format("Honor: %s HK: %s", TitanUtils_GetHighlightText(cp), TitanUtils_GetGreenText(z));

	return Text;
end

function TitanPanelHonorButton_GetTooltipText()
	local txt, hk, hc, ac, z;
	hk = GetPVPLifetimeStats();
	hc = GetHonorCurrency();
	ac = GetArenaCurrency();
	
	z = 0;
	for _ in pairs(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) do
		z = z + 1;
	end

	-- BG stats
	local bg, honorArr, avgHonor, avgTime, bgSession, dataPoints, bgstats;

	bgstats = "";

	
	for bg, honorArr in pairs(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory) do
		avgHonor = 0;
		avgTime = 0;

		dataPoints = table.getn(honorArr);
		
		for _, bgSession in pairs(honorArr) do
			avgHonor = avgHonor + bgSession.honor;
			avgTime = avgTime + bgSession.time;
		end
	
		avgHonor = math.floor(avgHonor / dataPoints);
		avgTime = math.floor(avgTime / dataPoints);

		bgstats =	bgstats.."\n"..TitanUtils_GetHighlightText(bg.." stats:").."\n"..
				TITAN_HONOR_AVEH..": \t"..TitanUtils_GetHighlightText(avgHonor).."\n"..
				TITAN_HONOR_AVET..": \t"..TitanUtils_GetHighlightText(avgTime).."\n"..
				TITAN_HONOR_AVEHPH..": \t"..TitanUtils_GetHighlightText(math.floor((avgHonor/avgTime)*60)).."\n"..
				"";



	end


	local txt, gained = 0;
	txt = "";
	if (TITAN_HONOR_InBattleground) then
		gained = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP - TITAN_HONOR_LastEstimated);
		txt =	"\n"..TitanUtils_GetHighlightText(TITAN_HONOR_CURRBG..": ").."\n"..
			TITAN_HONOR_HGSF..": \t"..TitanUtils_GetHighlightText(gained);
	end




	return ""..
		TitanUtils_GetHighlightText(TITAN_HONOR_CURRENCY..": ").."\n"..
		TITAN_HONOR_HP..": \t"..TitanUtils_GetHighlightText(hc).."\n"..
	-- uncomment on BC
	--	"Arena points: \t"..TitanUtils_GetHighlightText(ac).."\n"..
		"\n"..
		
		TitanUtils_GetHighlightText(TITAN_HONOR_TODAY..": ").."\n"..
		TITAN_HONOR_HK..": \t"..TitanUtils_GetGreenText(z).."\n"..
		TITAN_HONOR_HE..": \t"..TitanUtils_GetHighlightText(math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP)).."\n"..



		bgstats..txt..


	"";



end

function TitanPanelRightClickMenu_PrepareHonorMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_HONOR_ID].menuText);

  	TitanPanelRightClickMenu_AddSpacer();
  	TitanPanelRightClickMenu_AddCommand("Reset all BG-Stats", TITAN_HONOR_ID , "TitanPanelHonorButton_ResetBGStats");
	
	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_HONOR_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelHonorButton_ResetBGStats()

	TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory = { };

end
	

function TitanPanelHonorButton_GetPlayerName()
	local pname;

	pname = UnitName("player");
	if (pname and pname ~= UNKNOWNOBJECT and pname ~= UKNOWNBEING and pname ~= "Unknown Entity") then
		TitanPanelHonorButton_Login();
	end
end


function TitanPanelHonorButton_Login()

	TITAN_HONOR_PLAYER = UnitName("player").." "..GetCVar("realmName");

	-- new player?
	if (not TITAN_HONOR_KILLSLIFETIME[TITAN_HONOR_PLAYER]) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER] = { yesterdayHK = 0, yesterdayCP = 0};
		TITAN_HONOR_KILLSLIFETIME[TITAN_HONOR_PLAYER] = { logined = 1 };
		TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER] = {};
	end


	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = 0;
	end


	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory = {};
	end

	-- check for new day, reset if it is
	TitanPanelHonorButton_ResetToday();

end

function TitanPanelHonorButton_ResetToday()
	local hk, contribution;

	-- Yesterday's values
	hk, contribution = GetPVPYesterdayStats();

	-- if yesterday's values differ from when last logged in, wipe kills for today
	if (	TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayHK ~= hk or
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayCP ~= contribution
	) then
		-- new day
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayHK = hk;
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayCP = contribution;

		TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER] = {};

		-- wipe estinated CP for today
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = 0;
		
	end
end

function TitanPanelHonorButton_EstimateCP(ecp)
	if (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] > 10) then
		return 0
	elseif (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] == 1) then
		return ecp
	else
		return ecp - ( (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] - 1) / 10 * ecp );
	end
end
